/**
 ** AnalGlobal.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011, 2012 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

public class AnlGlobal {
    int nficom[][];
    int nfipel[][];
    int nfi6com[][];
    int nfi6pel[][];
    
    public AnlGlobal() {
    	nficom = new int[4][4];
    	nfipel = new int[4][4];
    	nfi6com = new int[4][4];
    	nfi6pel = new int[4][4];
    }
        
    public void clear() {
        for (int i=0; i<4; i++) {
            for (int j=0; j<4; j++){
                nficom[i][j] = 0;
                nfipel[i][j] = 0;
                nfi6com[i][j] = 0;
                nfi6pel[i][j] = 0;
            }
        }
    }
            
    public void anlN2(PosPartida mPP) {
    	this.clear();
            
        GrupoJugadas jpo = new GrupoJugadas();
        for (int c=0; c<4; c++)
            if (mPP.tipo_jugador[c] != DefPartida.NOJUEGA) {
                for (int dado=1; dado<7; dado++){
                    if (dado == 6 && mPP.nfcasa[c] == 0) dado++;
                    int nj = jpo.genera(mPP, c, dado);
                    for (int j=0; j<nj; j++) {
                        if (jpo.jg[j].come && jpo.jg[j].cjugdcom != Tablero.VACIO) {
                            nficom[c][jpo.jg[j].nficha]++;
                            nfipel[jpo.jg[j].cjugdcom][jpo.jg[j].nfichcom]++;
                        }
                    }
                }
            }
    }

    public void anlN3(PosPartida mPP) {
    	this.clear();
            
        GrupoJugadas jpo = new GrupoJugadas();
        GrupoJugadas jpo2 = new GrupoJugadas();
        for (int c=0; c<4; c++)
            if (mPP.tipo_jugador[c] != DefPartida.NOJUEGA) {
            	boolean yacontmeta = false;
                for (int dado=1; dado<7; dado++) {
                    if (dado == 6 && mPP.nfcasa[c] == 0) dado++;
                    int nj = jpo.genera(mPP, c, dado);
                    for (int j=0; j<nj; j++) {
                        if (jpo.jg[j].come && jpo.jg[j].cjugdcom != Tablero.VACIO) {
                            nficom[c][jpo.jg[j].nficha]++;
                            nfipel[jpo.jg[j].cjugdcom][jpo.jg[j].nfichcom]++;
                            if (jpo.jg[j].come2 && jpo.jg[j].cjugdcom2 != Tablero.VACIO) {
                                nfipel[jpo.jg[j].cjugdcom2][jpo.jg[j].nfichcom2]++;
                            }
                        } else if (!yacontmeta && jpo.jg[j].meta) {
                        	int nj2 = jpo2.genera(mPP, c, 10);
                        	for (int j2=0; j2<nj2; j2++) {
                                if (jpo2.jg[j2].come && jpo2.jg[j2].cjugdcom != Tablero.VACIO) {
                                    nfipel[jpo2.jg[j2].cjugdcom][jpo2.jg[j2].nfichcom]++;
                                }
                        	}
                        	yacontmeta = true;
                        }
                    }
                }
                /* ahora ver comibles y peligrosas si 6+n */
                int d6 = (mPP.nfcasa[c] == 0) ? 7 : 6;
                for (int f=0; f<3; f++) {
                	Jugada jg = new Jugada();
                	if (jg.genera(mPP, c, f, d6) == 0) break; /* no hay caso */
                	for (int dado=1; dado <7; dado++) {
                		if (dado == 6) dado = d6;
                		Jugada jg2 = new Jugada();
                		if (jg2.genera(mPP, c, f, d6+dado) == 0) break;
                		if (jg2.come && jg2.cjugdcom != Tablero.VACIO) {
                            nfi6com[c][f]++;
                            nfi6pel[jg2.cjugdcom][jg2.nfichcom]++;
                		}
                	}
                }
            }
    }
}
