/**
 ** BMDistancia.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011, 2012 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.PixelXorXfermode;
import android.graphics.RectF;
import android.graphics.Typeface;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;

public class BMDistancia {
    public Bitmap bm;
    int bmw, bmh;
    private Canvas mCanvas;
    private Paint mPaint;
    private Drawable fondo;
    private PixelXorXfermode pxor;
    private RectF rect;
    float ts1, ts2;
    int margh, pxt, pyt1, pyt2;
    
    public BMDistancia(Resources r, DisplayMetrics dm) {
    	bmw = dm.widthPixels;
    	bmh = (int)(bmw / 7.5);
    	bm = Bitmap.createBitmap(bmw, bmh, Bitmap.Config.ARGB_8888);
        mCanvas = new Canvas(bm);
        mPaint = new Paint();
        mCanvas.drawColor(0xff660000);
		bm.setDensity(dm.densityDpi);
		fondo = r.getDrawable(R.drawable.titulo);
//        fondo.setBounds(1, 1, bmw-1, bmh-1);
        fondo.setBounds(0, 0, bmw, bmh);
    	pxor = new PixelXorXfermode(0xffffffff);
    	rect = new RectF();
    	ts1 = (float)(bmw/20.0);
    	ts2 = (float)(bmw/30.0);
    	margh = bmh / 9; //7
    	pxt = (bmh-margh*2)/2;
    	pyt1 = (int)(bmh/1.684);
    	pyt2 = (int)(bmh/1.231);
    }
    
    public void draw(EstadoPartida mEP) {
        String s;
        int x = bmw / 2; //240
        
        mPaint.setAntiAlias(true);
        fondo.draw(mCanvas);
    	for (int c=EstadoPartida.AMAR; c<=EstadoPartida.VERD; c++) {
            mPaint.setStyle(Paint.Style.FILL);
            rect.set(x, margh, x+bmh-margh*2, bmh-margh);
            mPaint.setColor(Parchis4A.colorj[c]);
            int arco = ((320-mEP.distancia[c])*360)/320;
            mCanvas.drawArc(rect, 270, arco, true, mPaint);
            mPaint.setStyle(Paint.Style.STROKE);
            mPaint.setStrokeWidth(2);
            mPaint.setColor(Parchis4A.colorj2[c]);
           	mCanvas.drawArc(rect, 270, 360, false, mPaint);
            if (arco > 0) mCanvas.drawArc(rect, 270, arco, true, mPaint);
            if (mEP.tipo_jugador[c] != DefPartida.NOJUEGA) {
            	mPaint.setXfermode(pxor);
                s = Integer.toString((320-mEP.distancia[c])*100/320);
                mPaint.setStyle(Paint.Style.FILL);
                mPaint.setTextSize(ts1);
                mPaint.setTypeface(Typeface.DEFAULT_BOLD);
                mPaint.setColor(0xff000000);
                mPaint.setTextAlign(Paint.Align.CENTER);
                mCanvas.drawText(s, x+pxt, pyt1, mPaint);
                mPaint.setTypeface(Typeface.DEFAULT);
                mPaint.setTextSize(ts2);
                mCanvas.drawText("%", x+pxt, pyt2, mPaint);
            	mPaint.setXfermode(null);
            }
            x += bmw/8;
    	}
    }
}
