/**
 ** Carrera.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

public class Carrera {
	public boolean nula;    /* actualmente solo si entra o 1 sin especial */
	public boolean especial; /* tmeta, acasa o come son true */
	public boolean meta;    /* en la meta */
	public boolean tmeta;   /* todas en la meta */
	public boolean acasa;   /* a casa por tres seises */
	public boolean come;    /* come ficha */
    public int cjugador;
    public int nficha;
    public int npasos;
    public int sigpaso;
    public int cuentaespecial;
    public PosFicha paso[];
    public PosFicha posespecial;
    
    public Carrera(Jugada jg) {
    	cjugador = jg.cjugador;
    	nficha = jg.nficha;
    	meta = jg.meta;
    	tmeta = meta && (jg.destino.ind == 3);
    	acasa = jg.acasa;
    	come = jg.come;
    	npasos = jg.vdado-1;
    	nula = true;
    	especial = acasa || come || tmeta;
    	cuentaespecial = 0;
    	if (jg.entra) {
    		if (!come) return; // carrera nula
    		npasos = 0;
    	}
    	if (jg.acasa)
    		npasos = 0;
//    	if (jg.vdado == 1) return;
    	nula = false;
    	sigpaso = 0;
    	paso = new PosFicha[npasos];
    	for (int i=0; i<npasos; i++) {
    		paso[i] = new PosFicha();
    		if (i == 0) {
    			paso[0].lugar = jg.origen.lugar;
    			paso[0].pos = jg.origen.pos + 1;
    			paso[0].ind = 0;
    		} else {
    			paso[i].lugar = paso[i-1].lugar;
    			paso[i].pos = paso[i-1].pos + 1;
    			paso[i].ind = 0;
    		}
    		if (paso[i].lugar == PosFicha.CORREDOR) {
    			if (paso[i].pos-1 == Jugada.csal[cjugador]) {
    				paso[i].lugar = PosFicha.LLEGADA;
    				paso[i].pos = 0;
    			} else if (paso[i].pos > 67) {
    				paso[i].pos = 0;
    			}
    		}
    	}
    	if (especial) { // marca sitio para el posible especial
    	    posespecial = new PosFicha();
    	    posespecial.setPosicion(jg.destino);
    	}
    }
}
