/**
 ** EstadoPartida.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011, 2012 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Random;

import android.os.Bundle;

public class EstadoPartida extends PosPartida{
//	private static final String TAG = "Parchis4A";
	private static final Random RNG = new Random();
	
	//actions
	public static final int ACC_TIRADADO = 0;
	public static final int ACC_PARADADO = 1;
	public static final int ACC_MUEVE = 3;
	public static final int ACC_PASA = 7;
	public static final int ACC_PARTIDATERMINADA = 8;
	
	public int accion;
	public int vdado;
	public GrupoJugadas gjg;
	public int njgelegida;
	public int sigvdado;
	public int ultf_selec[];
	
	public EstadoPartida() {
		super();
		ultf_selec = new int[4];
        gjg = new GrupoJugadas();
	}

	/* Save game state in a bundle*/
    public Bundle saveState() {
        Bundle map = new Bundle();

        map.putIntArray("defp", ((DefPartida)this).toArray());
//        map.putIntArray("tj", tipo_jugador);
//        map.putIntArray("nm", nivel_maquina);
        map.putBooleanArray("hs", jgha_salido);
        map.putIntArray("ht", jgha_terminado);
        map.putInt("spfi", sig_pos_fin);
        map.putIntArray("pf", this.pos_ficha_to_array());
        map.putIntArray("nfcs", nfcasa);
        map.putIntArray("nfmt", nfmeta);
        map.putIntArray("ulfs", ultf_selec);
//        map.putBoolean("frp", fin_rapido);
//        map.putBoolean("frrp", finrobot_rapido);
//        map.putBoolean("dm", dado_manual);
//        map.putInt("njg", num_jg);
//        map.putInt("njgh", num_jgh);
//        map.putInt("njgr", num_jgr);
        map.putInt("tur", turno);
        map.putInt("n6", nseises);
        map.putInt("nfmv", nfmovida);
        map.putInt("acc", accion);
        map.putInt("vd", vdado);
        map.putInt("njge", njgelegida);
        map.putInt("sigv", sigvdado);
        map.putIntArray("estd1", estDado[0]);
        map.putIntArray("estd2", estDado[1]);
        map.putIntArray("estd3", estDado[2]);
        map.putIntArray("estd4", estDado[3]);
        map.putIntArray("esttd", estTotDado);
        map.putIntArray("estp", estPasa);
        map.putIntArray("estc", estCome);
        map.putIntArray("estm", estComida);
        map.putIntArray("estac", estACasa);

        return map;
    }

    public void restoreState(Bundle icicle) {
    	((DefPartida)this).set(icicle.getIntArray("defp"));
//    	tipo_jugador = icicle.getIntArray("tj");
//    	nivel_maquina = icicle.getIntArray("nm");
    	jgha_salido = icicle.getBooleanArray("hs");
    	jgha_terminado = icicle.getIntArray("ht");
    	sig_pos_fin = icicle.getInt("spfi");
    	this.array_to_pos_ficha(icicle.getIntArray("pf"));
    	nfcasa = icicle.getIntArray("nfcs");
    	nfmeta = icicle.getIntArray("nfmt");
    	ultf_selec = icicle.getIntArray("ulfs");
//    	fin_rapido = icicle.getBoolean("frp");
//    	finrobot_rapido = icicle.getBoolean("frrp");
//    	dado_manual = icicle.getBoolean("dm");
//    	num_jg = icicle.getInt("njg");
//    	num_jgh = icicle.getInt("njgh");
//    	num_jgr = icicle.getInt("njgr");
    	turno = icicle.getInt("tur");
    	nseises = icicle.getInt("n6");
    	nfmovida = icicle.getInt("nfmv");
    	accion = icicle.getInt("acc");
    	vdado = icicle.getInt("vd");
    	njgelegida = icicle.getInt("njge");
    	sigvdado = icicle.getInt("sigv");
    	estDado[0] = icicle.getIntArray("estd1");
    	estDado[1] = icicle.getIntArray("estd2");
    	estDado[2] = icicle.getIntArray("estd3");
    	estDado[3] = icicle.getIntArray("estd4");
    	estTotDado = icicle.getIntArray("esttd");
    	estPasa = icicle.getIntArray("estp");
    	estCome = icicle.getIntArray("estc");
    	estComida = icicle.getIntArray("estm");
    	estACasa = icicle.getIntArray("estac");
    	actualizaDistancias();
		mTbl.vaciaCasillas();
		mTbl.setPosPartida(this);
    }

    /* Save game state in a file*/
    public void saveState(ObjectOutputStream oout) throws IOException {
        oout.writeObject(((DefPartida)this).toArray());
//        oout.writeObject(tipo_jugador);
//        oout.writeObject(nivel_maquina);
        oout.writeObject(jgha_salido);
        oout.writeObject(jgha_terminado);
        oout.writeInt(sig_pos_fin);
        oout.writeObject(this.pos_ficha_to_array());
        oout.writeObject(nfcasa);
        oout.writeObject(nfmeta);
        oout.writeObject(ultf_selec);
//        oout.writeBoolean(fin_rapido);
//        oout.writeBoolean(finrobot_rapido);
//        oout.writeBoolean(dado_manual);
//        oout.writeInt(num_jg);
//        oout.writeInt(num_jgh);
//        oout.writeInt(num_jgr);
        oout.writeInt(turno);
        oout.writeInt(nseises);
        oout.writeInt(nfmovida);
        oout.writeInt(accion);
        oout.writeInt(vdado);
        oout.writeInt(njgelegida);
        oout.writeInt(sigvdado);
        oout.writeObject(estDado[0]);
        oout.writeObject(estDado[1]);
        oout.writeObject(estDado[2]);
        oout.writeObject(estDado[3]);
        oout.writeObject(estTotDado);
        oout.writeObject(estPasa);
        oout.writeObject(estCome);
        oout.writeObject(estComida);
        oout.writeObject(estACasa);
    }

    public void restoreState(ObjectInputStream oin) throws IOException, ClassNotFoundException {
    	((DefPartida)this).set((int[])oin.readObject());
//    	tipo_jugador = (int[])oin.readObject();
//    	nivel_maquina = (int[])oin.readObject();
    	jgha_salido = (boolean[])oin.readObject();
    	jgha_terminado = (int[])oin.readObject();
    	sig_pos_fin = oin.readInt();
    	this.array_to_pos_ficha((int[])oin.readObject());
    	nfcasa = (int[])oin.readObject();
    	nfmeta = (int[])oin.readObject();
    	ultf_selec = (int[])oin.readObject();
//    	fin_rapido = oin.readBoolean();
//    	finrobot_rapido = oin.readBoolean();
//    	dado_manual = oin.readBoolean();
//    	num_jg = oin.readInt();
//    	num_jgh = oin.readInt();
//    	num_jgr = oin.readInt();
    	turno = oin.readInt();
    	nseises = oin.readInt();
    	nfmovida = oin.readInt();
    	accion = oin.readInt();
    	vdado = oin.readInt();
    	njgelegida = oin.readInt();
    	sigvdado = oin.readInt();
    	estDado[0] = (int[])oin.readObject();
    	estDado[1] = (int[])oin.readObject();
    	estDado[2] = (int[])oin.readObject();
    	estDado[3] = (int[])oin.readObject();
    	estTotDado = (int[])oin.readObject();
    	estPasa = (int[])oin.readObject();
    	estCome = (int[])oin.readObject();
    	estComida = (int[])oin.readObject();
    	estACasa = (int[])oin.readObject();
    	actualizaDistancias();
		mTbl.vaciaCasillas();
		mTbl.setPosPartida(this);
    }

	public void iniciaPartida(DefPartida defP) {
		posInicial(defP);
		accion = ACC_TIRADADO;
		sigvdado = 0;
        njgelegida = -1;
		for (int c=AMAR; c<=VERD; c++)
		    ultf_selec[c] = -1;
        if (haTerminado()) accion = ACC_PARTIDATERMINADA; // no hay jugadores
	}
	
	public void avanzaTurnoP() {
		if (!avanzaTurno()) {
			accion = ACC_PARTIDATERMINADA;
			return;
		}
		if (sigvdado == -1) { // acaba de terminar uno
			if (compruebaFinalRapido()) {
				accion = ACC_PARTIDATERMINADA;
				return;
			}
		}
	}
	
	public void iniciaAccion(int vdadoManual) {
		if (accion == ACC_PARADADO) {
            if (vdadoManual > 0)
            	vdado = vdadoManual;
            else
			    vdado = RNG.nextInt(6) + 1;
			nseises = (vdado == 6) ? nseises+1 : 0;
	    	estDado[turno][vdado-1]++;
	    	estTotDado[turno]++;
			if (vdado == 6 && nfcasa[turno] == 0) vdado = 7; // hace 6 a 7
		} else if (accion == ACC_MUEVE) {
//			gjg.jg[njgelegida].impLog();
			sigvdado = realizaJugada(gjg.jg[njgelegida]);
            actualizaDistancias();
			if (gjg.njugadas > 1) {
				ultf_selec[gjg.jg[njgelegida].cjugador] = gjg.jg[njgelegida].nficha;
			}
            njgelegida = -1;
		} else if (accion == ACC_PASA) {
			estPasa[turno]++;
			sigvdado = 0;
		}
	}

	private int jugadaPorDefecto(int nj) {
		int jeleg = 0;
		
		if (nj < 2) return jeleg;
		int color = gjg.jg[0].cjugador;
		if (ultf_selec[color] < 0) return jeleg;
		for (int i=0; i<nj; i++) {
			if (gjg.jg[i].nficha == ultf_selec[color]) {
				jeleg = i;
				break;
			}
		}
		return jeleg;
	}
	
	public void terminaAccion() {
		if (accion == ACC_TIRADADO) {
			accion = ACC_PARADADO;
		} else if (accion == ACC_PARADADO) {
            int n = gjg.genera(this, turno, vdado);
            if (n > 0) {
                njgelegida = jugadaPorDefecto(n);
                if (tipo_jugador[turno] == DefPartida.MAQUINA)
                	eligeJugadaMaquina();
            	accion = ACC_MUEVE;
            } else {
                njgelegida = -1;
            	accion = ACC_PASA;
            }
		} else if (accion == ACC_PASA) {
		    accion = ACC_TIRADADO;
		    if (sigvdado == -1 || nseises == 0 || nseises >2)
  		        avanzaTurnoP();
		} else if (accion == ACC_MUEVE) {
			if (sigvdado == 10 || sigvdado == 20) {
				vdado = sigvdado;
	            int n = gjg.genera(this, turno, vdado);
	            if (n > 0) {
	                njgelegida = jugadaPorDefecto(n);
	                if (tipo_jugador[turno] == DefPartida.MAQUINA)
	                	eligeJugadaMaquina();
	            	accion = ACC_MUEVE;
	            } else {
	                njgelegida = -1;
	            	accion = ACC_PASA;
	            }
			} else {
  		        accion = ACC_TIRADADO;
  		        if (sigvdado == -1 || nseises == 0 || nseises >2)
		            avanzaTurnoP();
			}
	    }
	}
	
	public void eligeJugadaMaquina() {
		int i, v, valor = -32000;
		
        if (gjg.njugadas < 2) return;
        
		gjg.completaInfoAnl(this);
		for (i=0; i<gjg.njugadas; i++) {
			v = gjg.jg[i].calculaPeso(nivel_maquina[turno]);
			if (v > valor) {
				valor = v;
				njgelegida = i;
			}
		}
	}
	
}