/**
 ** HistPartida.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011, 2012 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

import java.util.ArrayList;

public class HistPartida {
	public static final int HP_TIRA = 0; // par1=color
	public static final int HP_MUEVE = 1; // par1=dado par2=nficha
	public static final int HP_PASA = 2; // par1=dado
	public static final int HP_ACASA = 3; // par1=dado par2=nficha

	private ArrayList<RegHist> vregh;
	private int numAcc;

	public HistPartida() {
		vregh = new ArrayList<RegHist>();
		numAcc = 0;
	}

	public int size() {
		return vregh.size();
	}
	
	public int getNumAcc(){
		return numAcc;
	}
	
	public void addAcc(int a, int p1, int p2) {
		RegHist r = new RegHist(a, p1, p2);
		vregh.add(r);
	}

	public static class RegHist {
		int acc;
		int par1;
		int par2;
		
		public RegHist(int a, int p1, int p2) {
			acc = a;
			par1 = p1;
			par2 = p2;
		}
	}

}
