/**
 ** NuevoJuego.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011, 2012 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.drawable.AnimationDrawable;
import android.graphics.drawable.BitmapDrawable;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

public class NuevoJuego extends Activity {
	
    public static final int DIALOG_SELECTPLAYERS_ID = 0;
    public static final int DIALOG_SELECTPLAYERS2_ID = 1;
    public static final int DIALOG_SELECTPLAYERS3_ID = 2;
    public static final int DIALOG_SELECTPLAYERS3_FAV_ID = 4;
    public static final int DIALOG_NEW_ID = 5;
    public static final int DIALOG_ABOUT_ID = 6;
    public static final int DIALOG_HELP_ID = 7;

	private static final String nameFavButton[] = {" A", " B", " C", " D"};

	private Resources resG;
	private Button bAccion[] = new Button[12];
	private DefPartida mDPpre3r0 = new DefPartida(DefPartida.MAQUINA, DefPartida.MAQUINA,
            DefPartida.PERSONA, DefPartida.MAQUINA, 0, 0, 0, 0);
	private DefPartida mDPpre3r1 = new DefPartida(DefPartida.MAQUINA, DefPartida.MAQUINA,
            DefPartida.MAQUINA, DefPartida.PERSONA, 1, 1, 1, 1);
	private DefPartida mDPpre3r2 = new DefPartida(DefPartida.PERSONA, DefPartida.MAQUINA,
	        DefPartida.MAQUINA, DefPartida.MAQUINA, 2, 2, 2, 2);
	private DefPartida mDPpre3r3 = new DefPartida(DefPartida.MAQUINA, DefPartida.PERSONA,
            DefPartida.MAQUINA, DefPartida.MAQUINA, 3, 3, 3, 3);
	private DefPartida mDPpre1r2 = new DefPartida(DefPartida.NOJUEGA, DefPartida.PERSONA,
            DefPartida.NOJUEGA, DefPartida.MAQUINA, 2, 2, 2, 2);
	private DefPartida mDPpre2h = new DefPartida(DefPartida.PERSONA, DefPartida.NOJUEGA,
            DefPartida.PERSONA, DefPartida.NOJUEGA, 2, 2, 2, 2);
	private DefPartida mDPpre4h = new DefPartida(DefPartida.PERSONA, DefPartida.PERSONA,
            DefPartida.PERSONA, DefPartida.PERSONA, 2, 2, 2, 2);

	private RadioGroup mRG_tipo_jugador[];
	private EditText mET_nombre[];
	private TextView mTV_persona[];
	private TextView mTV_nojuega[];
	private RadioGroup mRG_nivel_maquina[];
	private int selectPlayersAction = -1;
	AnimationDrawable promoAnimation;
	
    Button.OnLongClickListener bfavOnLongClick = new Button.OnLongClickListener() {
        public boolean onLongClick(View v) {
        	int ind = -1;
        	for (int i=0; i<4; i++)
        		if (bAccion[8+i] == (Button)v) ind = i;
        	if (ind < 0) return true;
        	selectPlayersAction = ind;
      	    showDialog(DIALOG_SELECTPLAYERS_ID);
  	        return true;
        }};

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        mRG_tipo_jugador = new RadioGroup[4];
        mRG_nivel_maquina = new RadioGroup[4];
        mET_nombre = new EditText[4];
        mTV_persona = new TextView[4];
        mTV_nojuega = new TextView[4];
        resG = getResources();
        setContentView(R.layout.nuevo_juego_layout);
        bAccion[0] = (Button) findViewById(R.id.njuego_3r0_button);
        bAccion[1] = (Button) findViewById(R.id.njuego_3r1_button);
        bAccion[2] = (Button) findViewById(R.id.njuego_3r2_button);
        bAccion[3] = (Button) findViewById(R.id.njuego_3r3_button);
        bAccion[4] = (Button) findViewById(R.id.njuego_select_button);
        bAccion[5] = (Button) findViewById(R.id.njuego_1r2_button);
        bAccion[6] = (Button) findViewById(R.id.njuego_2h_button);
        bAccion[7] = (Button) findViewById(R.id.njuego_4h_button);
        bAccion[8] = (Button) findViewById(R.id.njuego_fav1_button);
        bAccion[9] = (Button) findViewById(R.id.njuego_fav2_button);
        bAccion[10] = (Button) findViewById(R.id.njuego_fav3_button);
        bAccion[11] = (Button) findViewById(R.id.njuego_fav4_button);
        drawIconsOnButtons();
        bAccion[8].setOnLongClickListener(bfavOnLongClick);
        bAccion[9].setOnLongClickListener(bfavOnLongClick);
        bAccion[10].setOnLongClickListener(bfavOnLongClick);
        bAccion[11].setOnLongClickListener(bfavOnLongClick);
        drawIconsOnFavButtons();
        ImageView promoImage = (ImageView) findViewById(R.id.njuego_promo);
        promoAnimation = (AnimationDrawable) promoImage.getDrawable();
    }
    
    @Override
    protected void onStart() {
        super.onStart();

        SharedPreferences prefs =
        	PreferenceManager.getDefaultSharedPreferences(getBaseContext());
        Parchis4A.enableGlobalStats = prefs.getBoolean("EnableGlobalStats", true);
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
    	super.onWindowFocusChanged(hasFocus);
    	if (hasFocus)
    		promoAnimation.start();
    }
    
    private void drawIconsOnButtons() {
       	Bitmap bmpre3r0 = BMPlayerGroup.Generate(resG, mDPpre3r0, true);
    	BitmapDrawable bmdpre3r0 = new BitmapDrawable(resG, bmpre3r0);
        bAccion[0].setCompoundDrawablesWithIntrinsicBounds(null, bmdpre3r0, null, null);
       	Bitmap bmpre3r1 = BMPlayerGroup.Generate(resG, mDPpre3r1, true);
    	BitmapDrawable bmdpre3r1 = new BitmapDrawable(resG, bmpre3r1);
        bAccion[1].setCompoundDrawablesWithIntrinsicBounds(null, bmdpre3r1, null, null);
       	Bitmap bmpre3r2 = BMPlayerGroup.Generate(resG, mDPpre3r2, true);
    	BitmapDrawable bmdpre3r2 = new BitmapDrawable(resG, bmpre3r2);
        bAccion[2].setCompoundDrawablesWithIntrinsicBounds(null, bmdpre3r2, null, null);
       	Bitmap bmpre3r3 = BMPlayerGroup.Generate(resG, mDPpre3r3, true);
    	BitmapDrawable bmdpre3r3 = new BitmapDrawable(resG, bmpre3r3);
        bAccion[3].setCompoundDrawablesWithIntrinsicBounds(null, bmdpre3r3, null, null);
    	Bitmap bmselect = BMPlayerGroup.GenerateGQm(resG, 1, true);
    	BitmapDrawable bmdselect = new BitmapDrawable(resG, bmselect);
    	bAccion[4].setCompoundDrawablesWithIntrinsicBounds(null, bmdselect, null, null);
       	Bitmap bmpre1r2 = BMPlayerGroup.Generate(resG, mDPpre1r2, true);
    	BitmapDrawable bmdpre1r2 = new BitmapDrawable(resG, bmpre1r2);
        bAccion[5].setCompoundDrawablesWithIntrinsicBounds(null, bmdpre1r2, null, null);
       	Bitmap bmpre2h = BMPlayerGroup.Generate(resG, mDPpre2h, true);
    	BitmapDrawable bmdpre2h = new BitmapDrawable(resG, bmpre2h);
        bAccion[6].setCompoundDrawablesWithIntrinsicBounds(null, bmdpre2h, null, null);
       	Bitmap bmpre4h = BMPlayerGroup.Generate(resG, mDPpre4h, true);
    	BitmapDrawable bmdpre4h = new BitmapDrawable(resG, bmpre4h);
        bAccion[7].setCompoundDrawablesWithIntrinsicBounds(null, bmdpre4h, null, null);
    }
    
    private void drawIconsOnFavButtons() {
    	Bitmap bmfav;
    	BitmapDrawable bmdfav;
    	Bitmap bmfavq = BMPlayerGroup.GenerateGQm(resG, 2, true);
    	BitmapDrawable bmdfavq = new BitmapDrawable(resG, bmfavq);
    	for (int i=0; i<4; i++) {
        	if (Parchis4A.mDPfav[i] != null){
            	bmfav = BMPlayerGroup.Generate(resG, Parchis4A.mDPfav[i], true);
            	bmdfav = new BitmapDrawable(resG, bmfav);
                bAccion[8+i].setCompoundDrawablesWithIntrinsicBounds(null, bmdfav, null, null);
        	} else
        		bAccion[8+i].setCompoundDrawablesWithIntrinsicBounds(null, bmdfavq, null, null);
    	}
    }

    public void bSeleccion(View v) {
    	if (bAccion[0] == (Button)v) {
    		Parchis4A.mDPactual.set(mDPpre3r0);
    		setResult(RESULT_OK);
    		finish();
    	} else if (bAccion[1] == (Button)v) {
    		Parchis4A.mDPactual.set(mDPpre3r1);
    		setResult(RESULT_OK);
    		finish();
    	} else if (bAccion[2] == (Button)v) {
    		Parchis4A.mDPactual.set(mDPpre3r2);
    		setResult(RESULT_OK);
    		finish();
    	} else if (bAccion[3] == (Button)v) {
    		Parchis4A.mDPactual.set(mDPpre3r3);
    		setResult(RESULT_OK);
    		finish();
    	} else if (bAccion[4] == (Button)v) {
        	selectPlayersAction = -1;
      	    showDialog(DIALOG_SELECTPLAYERS_ID);
    	} else if (bAccion[5] == (Button)v) {
    		Parchis4A.mDPactual.set(mDPpre1r2);
    		setResult(RESULT_OK);
    		finish();
    	} else if (bAccion[6] == (Button)v) {
    		Parchis4A.mDPactual.set(mDPpre2h);
    		setResult(RESULT_OK);
    		finish();
    	} else if (bAccion[7] == (Button)v) {
    		Parchis4A.mDPactual.set(mDPpre4h);
    		setResult(RESULT_OK);
    		finish();
    	} else {
    	    int ind = -1;
    	    for (int i=0; i<4; i++)
    		    if (bAccion[8+i] == (Button)v) ind = i;
    	    if (ind < 0) return;
    	    if (Parchis4A.mDPfav[ind] != null) {
                Parchis4A.mDPactual.set(Parchis4A.mDPfav[ind]);
        		setResult(RESULT_OK);
        		finish();
    	    } else {
    		    Toast.makeText(getApplicationContext(),
    				R.string.toast_nodefined, Toast.LENGTH_SHORT).show();
    	    }
    	}
    }

    public void bNews(View v) {
    	showDialog(DIALOG_NEW_ID);
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.nuevo_juego_menu, menu);
    	menu.findItem(R.id.menu_settings).setIcon(
            getResources().getDrawable(android.R.drawable.ic_menu_preferences));
    	menu.findItem(R.id.menu_help).setIcon(
            getResources().getDrawable(android.R.drawable.ic_menu_help));
    	menu.findItem(R.id.menu_reg).setIcon(
            getResources().getDrawable(android.R.drawable.ic_menu_info_details));
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
        case R.id.menu_settings:
        	Intent settingsActivity = new Intent(getBaseContext(), Preferences.class);
            startActivity(settingsActivity);
            return true;
        case R.id.menu_reg:
        	if (Parchis4A.enableGlobalStats) {
        	    Intent regActivity = new Intent(getBaseContext(), RegistroAct.class);
                startActivity(regActivity);
        	} else {
                Toast.makeText(this, R.string.toast_noglobalstats, Toast.LENGTH_LONG).show();
        	}
            return true;
        case R.id.menu_help:
        	showDialog(DIALOG_HELP_ID);
            return true;
       default:
            return super.onOptionsItemSelected(item);
        }
    }

    @Override
    protected Dialog onCreateDialog(int id) {
        Dialog dialog;

        switch(id) {
        case DIALOG_SELECTPLAYERS_ID:
        	dialog = new Dialog(this);
        	dialog.setContentView(R.layout.select_players);
        	dialog.setCancelable(true);
            dialog.setCanceledOnTouchOutside(true);
        	dialog.setTitle(resG.getString(R.string.select_players_title));
        	mRG_tipo_jugador[0] = (RadioGroup) dialog.findViewById(R.id.sp1radioGroup1);
        	mRG_tipo_jugador[1] = (RadioGroup) dialog.findViewById(R.id.sp1radioGroup2);
        	mRG_tipo_jugador[2] = (RadioGroup) dialog.findViewById(R.id.sp1radioGroup3);
        	mRG_tipo_jugador[3] = (RadioGroup) dialog.findViewById(R.id.sp1radioGroup4);

            Button selectpDialogOkButton = (Button) dialog.findViewById(R.id.select_players_ok_button);
            selectpDialogOkButton.setOnClickListener(new Button.OnClickListener() {
                public void onClick(View v) {
                	for (int j=0; j<4; j++) {
                    	int id = mRG_tipo_jugador[j].getCheckedRadioButtonId();
                		if (id == R.id.radio0) {
                			Parchis4A.mDPnuevo.tipo_jugador[j] = DefPartida.PERSONA;
                		} else if (id == R.id.radio1) {
                			Parchis4A.mDPnuevo.tipo_jugador[j] = DefPartida.MAQUINA;
                		} else {
                			Parchis4A.mDPnuevo.tipo_jugador[j] = DefPartida.NOJUEGA;
                		}
                	}
                	Parchis4A.mDPnuevo.cuentaJg();
                	if (Parchis4A.mDPnuevo.num_jgr > 0)
                        showDialog(DIALOG_SELECTPLAYERS2_ID);
                	else {
                		if (selectPlayersAction >=0 && selectPlayersAction <4)
                            showDialog(DIALOG_SELECTPLAYERS3_FAV_ID);
                		else
                            showDialog(DIALOG_SELECTPLAYERS3_ID);
                	}
                }
            });

            Button selectpDialogCancelButton = (Button) dialog.findViewById(R.id.select_players_cancel_button);
            selectpDialogCancelButton.setOnClickListener(new Button.OnClickListener() {
                public void onClick(View v) {
                    dismissDialog(DIALOG_SELECTPLAYERS_ID);
                }
            });

            break;
        case DIALOG_SELECTPLAYERS2_ID:
        	dialog = new Dialog(this);
        	dialog.setContentView(R.layout.select_players2);
        	dialog.setCancelable(true);
            dialog.setCanceledOnTouchOutside(true);
        	dialog.setTitle(resG.getString(R.string.select_players2_title));
        	mRG_nivel_maquina[0] = (RadioGroup) dialog.findViewById(R.id.sp2radioGroup1);
        	mRG_nivel_maquina[1] = (RadioGroup) dialog.findViewById(R.id.sp2radioGroup2);
        	mRG_nivel_maquina[2] = (RadioGroup) dialog.findViewById(R.id.sp2radioGroup3);
        	mRG_nivel_maquina[3] = (RadioGroup) dialog.findViewById(R.id.sp2radioGroup4);
        	mET_nombre[0] = (EditText) dialog.findViewById(R.id.sp2entry1);
        	mET_nombre[1] = (EditText) dialog.findViewById(R.id.sp2entry2);
        	mET_nombre[2] = (EditText) dialog.findViewById(R.id.sp2entry3);
        	mET_nombre[3] = (EditText) dialog.findViewById(R.id.sp2entry4);
        	mTV_persona[0] = (TextView) dialog.findViewById(R.id.sp2text01);
        	mTV_persona[1] = (TextView) dialog.findViewById(R.id.sp2text02);
        	mTV_persona[2] = (TextView) dialog.findViewById(R.id.sp2text03);
        	mTV_persona[3] = (TextView) dialog.findViewById(R.id.sp2text04);
        	mTV_nojuega[0] = (TextView) dialog.findViewById(R.id.sp2text11);
        	mTV_nojuega[1] = (TextView) dialog.findViewById(R.id.sp2text12);
        	mTV_nojuega[2] = (TextView) dialog.findViewById(R.id.sp2text13);
        	mTV_nojuega[3] = (TextView) dialog.findViewById(R.id.sp2text14);

            Button selectp2DialogOkButton = (Button) dialog.findViewById(R.id.select_players2_ok_button);
            selectp2DialogOkButton.setOnClickListener(new Button.OnClickListener() {
                public void onClick(View v) {
                	for (int j=0; j<4; j++) {
                    	int id = mRG_nivel_maquina[j].getCheckedRadioButtonId();
                		if (id == R.id.radio0) Parchis4A.mDPnuevo.nivel_maquina[j] = DefPartida.NIVEL0;
                		else if (id == R.id.radio1) Parchis4A.mDPnuevo.nivel_maquina[j] = DefPartida.NIVEL1;
                		else if (id == R.id.radio2) Parchis4A.mDPnuevo.nivel_maquina[j] = DefPartida.NIVEL2;
                		else Parchis4A.mDPnuevo.nivel_maquina[j] = DefPartida.NIVEL3;
                	}
            		if (selectPlayersAction >=0 && selectPlayersAction <4)
                        showDialog(DIALOG_SELECTPLAYERS3_FAV_ID);
            		else
                        showDialog(DIALOG_SELECTPLAYERS3_ID);
                }
            });

            Button selectp2DialogCancelButton = (Button) dialog.findViewById(R.id.select_players2_cancel_button);
            selectp2DialogCancelButton.setOnClickListener(new Button.OnClickListener() {
                public void onClick(View v) {
                    dismissDialog(DIALOG_SELECTPLAYERS2_ID);
                }
            });

            break;
        case DIALOG_SELECTPLAYERS3_ID:
        	dialog = new Dialog(this);
        	dialog.setContentView(R.layout.select_players3);
        	dialog.setCancelable(true);
            dialog.setCanceledOnTouchOutside(true);
        	dialog.setTitle(resG.getString(R.string.select_players3_title));
//        	mCB_fin_rapido = (CheckBox) dialog.findViewById(R.id.checkBoxSp1);
//        	mCB_favorito = (CheckBox) dialog.findViewById(R.id.checkBoxSp2);

            Button selectp3DialogOkButton = (Button) dialog.findViewById(R.id.select_players3_ok_button);
            selectp3DialogOkButton.setOnClickListener(new Button.OnClickListener() {
                public void onClick(View v) {
            		Parchis4A.mDPactual.set(Parchis4A.mDPnuevo);
                    dismissDialog(DIALOG_SELECTPLAYERS_ID);
                    if (Parchis4A.mDPnuevo.num_jgr > 0) dismissDialog(DIALOG_SELECTPLAYERS2_ID);
                    dismissDialog(DIALOG_SELECTPLAYERS3_ID);
            		setResult(RESULT_OK);
            		finish();
                }
            });

            Button selectp3DialogCancelButton = (Button) dialog.findViewById(R.id.select_players3_cancel_button);
            selectp3DialogCancelButton.setOnClickListener(new Button.OnClickListener() {
                public void onClick(View v) {
                    dismissDialog(DIALOG_SELECTPLAYERS3_ID);
                }
            });

            break;
        case DIALOG_SELECTPLAYERS3_FAV_ID:
        	dialog = new Dialog(this);
        	dialog.setContentView(R.layout.select_players3_fav);
        	dialog.setCancelable(true);
            dialog.setCanceledOnTouchOutside(true);
        	dialog.setTitle(resG.getString(R.string.select_players3_fav_title));

            Button selectp3FavDialogOkButton = (Button) dialog.findViewById(R.id.select_players3_fav_ok_button);
            selectp3FavDialogOkButton.setOnClickListener(new Button.OnClickListener() {
                public void onClick(View v) {
                	if (Parchis4A.mDPfav[selectPlayersAction] == null) 
                		Parchis4A.mDPfav[selectPlayersAction] = new DefPartida();
                	Parchis4A.mDPfav[selectPlayersAction].set(Parchis4A.mDPnuevo);
                    dismissDialog(DIALOG_SELECTPLAYERS_ID);
                    if (Parchis4A.mDPnuevo.num_jgr > 0) dismissDialog(DIALOG_SELECTPLAYERS2_ID);
                    drawIconsOnFavButtons();
                    Parchis4A.recuperaFavoritos = false;
                    dismissDialog(DIALOG_SELECTPLAYERS3_FAV_ID);
                }
            });

            Button selectp3FavDialogCancelButton = (Button) dialog.findViewById(R.id.select_players3_fav_cancel_button);
            selectp3FavDialogCancelButton.setOnClickListener(new Button.OnClickListener() {
                public void onClick(View v) {
                    dismissDialog(DIALOG_SELECTPLAYERS3_FAV_ID);
                }
            });

            break;
        case DIALOG_NEW_ID:
        	LayoutInflater inflatern = (LayoutInflater) getSystemService(LAYOUT_INFLATER_SERVICE);
        	View layoutn = inflatern.inflate(R.layout.new_layout,
                    (ViewGroup) findViewById(R.id.new_layout_root));
        	AlertDialog.Builder buildern = new AlertDialog.Builder(this);
        	buildern.setTitle(R.string.new_title);
        	buildern.setIcon(R.drawable.icon);
        	buildern.setView(layoutn);

        	buildern.setPositiveButton(R.string.dlg_ok,
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                    	dialog.cancel();
                    }
                });
        	
        	buildern.setNegativeButton(R.string.dlg_go_market,
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                      	Intent goToMarket = null;
                       	goToMarket = new Intent(Intent.ACTION_VIEW,Uri.parse("market://details?id=com.fgrim.parchis4a"));
                       	goToMarket.addFlags(Intent.FLAG_ACTIVITY_CLEAR_WHEN_TASK_RESET);
                       	startActivity(goToMarket);
                       	dialog.cancel();
                    }
                });
            	
        	dialog = buildern.create();
        	dialog.setCancelable(true);
            break;
        case DIALOG_ABOUT_ID:
        	LayoutInflater inflatera = (LayoutInflater) getSystemService(LAYOUT_INFLATER_SERVICE);
        	View layouta = inflatera.inflate(R.layout.about_layout,
                    (ViewGroup) findViewById(R.id.about_layout_root));
        	AlertDialog.Builder buildera = new AlertDialog.Builder(this);
        	buildera.setTitle(R.string.about_title);
        	buildera.setIcon(R.drawable.icon);
        	buildera.setView(layouta);

        	buildera.setPositiveButton(R.string.dlg_ok,
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                    	showDialog(DIALOG_HELP_ID);
                    	dialog.cancel();
                    }
                });
        	
        	dialog = buildera.create();
        	dialog.setCancelable(true);
            break;
        case DIALOG_HELP_ID:
        	LayoutInflater inflaterh = (LayoutInflater) getSystemService(LAYOUT_INFLATER_SERVICE);
        	View layouth = inflaterh.inflate(R.layout.help_layout,
                    (ViewGroup) findViewById(R.id.help_layout_root));
        	AlertDialog.Builder builderh = new AlertDialog.Builder(this);
        	builderh.setTitle(R.string.help_title);
        	builderh.setIcon(R.drawable.icon);
        	builderh.setView(layouth);

        	builderh.setPositiveButton(R.string.dlg_ok,
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                    	dialog.cancel();
                    }
                });
            builderh.setNegativeButton(R.string.help_about,
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        showDialog(DIALOG_ABOUT_ID);
       	                dialog.cancel();
                    }
                });
        	
        	dialog = builderh.create();
        	dialog.setCancelable(true);
            break;
        default:
            dialog = null;
        }
        return dialog;
    }

    @Override
    protected void onPrepareDialog(int id, Dialog dialog) {
        switch(id) {
        case DIALOG_SELECTPLAYERS_ID:
      		Parchis4A.mDPnuevo.set(Parchis4A.mDPactual);
      		if (selectPlayersAction >=0 && selectPlayersAction <4 && Parchis4A.mDPfav[selectPlayersAction] != null)
      			Parchis4A.mDPnuevo.set(Parchis4A.mDPfav[selectPlayersAction]);
      		for (int j=0; j<4; j++) {
      			if (Parchis4A.mDPnuevo.tipo_jugador[j] == DefPartida.PERSONA) mRG_tipo_jugador[j].check(R.id.radio0);
      			else if (Parchis4A.mDPnuevo.tipo_jugador[j] == DefPartida.MAQUINA) mRG_tipo_jugador[j].check(R.id.radio1);
      			else mRG_tipo_jugador[j].check(R.id.radio2);
      		}
      	break;
      case DIALOG_SELECTPLAYERS2_ID:
      		for (int j=0; j<4; j++) {
          		if (Parchis4A.mDPnuevo.nivel_maquina[j] == DefPartida.NIVEL0) mRG_nivel_maquina[j].check(R.id.radio0);
          		else if (Parchis4A.mDPnuevo.nivel_maquina[j] == DefPartida.NIVEL1) mRG_nivel_maquina[j].check(R.id.radio1);
          		else if (Parchis4A.mDPnuevo.nivel_maquina[j] == DefPartida.NIVEL2) mRG_nivel_maquina[j].check(R.id.radio2);
          		else mRG_nivel_maquina[j].check(R.id.radio3);
      		}
      	for (int j=0; j<4; j++) {
      		if (Parchis4A.mDPnuevo.tipo_jugador[j] == DefPartida.MAQUINA) {
//      			mET_nombre[j].setVisibility(View.GONE);
      			mTV_persona[j].setVisibility(View.GONE);
      			mTV_nojuega[j].setVisibility(View.GONE);
      			mRG_nivel_maquina[j].setVisibility(View.VISIBLE);
      		} else if (Parchis4A.mDPnuevo.tipo_jugador[j] == DefPartida.PERSONA) {
//      			mET_nombre[j].setVisibility(View.VISIBLE);
      			mTV_persona[j].setVisibility(View.VISIBLE);
      			mTV_nojuega[j].setVisibility(View.GONE);
      			mRG_nivel_maquina[j].setVisibility(View.GONE);
      		} else {
//      			mET_nombre[j].setVisibility(View.GONE);
      			mTV_persona[j].setVisibility(View.GONE);
      			mTV_nojuega[j].setVisibility(View.VISIBLE);
      			mRG_nivel_maquina[j].setVisibility(View.GONE);
      		}
      	}
          break;
      case DIALOG_SELECTPLAYERS3_ID:
      	  ImageView mIViewsp3 = (ImageView) dialog.findViewById(R.id.bmgroup);
      	  Bitmap bmsp3 = BMPlayerGroup.Generate(resG, Parchis4A.mDPnuevo, false);
      	  mIViewsp3.setImageBitmap(bmsp3);
          break;
      case DIALOG_SELECTPLAYERS3_FAV_ID:
      	  String snfb = getString(R.string.select_players3_fav_title);
      	  if (selectPlayersAction >=0 && selectPlayersAction <4)
      	      snfb += nameFavButton[selectPlayersAction];
      	  dialog.setTitle(snfb);
      	  ImageView mIViewsp3f = (ImageView) dialog.findViewById(R.id.bmgroupfav);
      	  Bitmap bmsp3f = BMPlayerGroup.Generate(resG, Parchis4A.mDPnuevo, false);
      	  mIViewsp3f.setImageBitmap(bmsp3f);
          break;
      }
  }

}
